unit uHTTPServer_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, IdBaseComponent, IdComponent, IdCustomTCPServer, IdCustomHTTPServer,
  IdHTTPServer, Vcl.StdCtrls,

  HTTPApp,
  IdMultipartFormData, IdContext,


  uDecodePOstRequest

  ;



type
  TfHTTPServer = class(TForm)
    bToggleStartStopServer: TButton;
    IdHTTPServer: TIdHTTPServer;
    mmo1: TMemo;
    mmo2: TMemo;
    mmo3: TMemo;
    procedure bToggleStartStopServerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IdHTTPServerCommandGet(AContext: TIdContext; ARequestInfo: TIdHTTPRequestInfo;
      AResponseInfo: TIdHTTPResponseInfo);
    procedure mmo2Change(Sender: TObject);
  private


  public
    { Public declarations }
  end;

var
  fHTTPServer: TfHTTPServer;

implementation

{$R *.dfm}






procedure TfHTTPServer.bToggleStartStopServerClick(Sender: TObject);
begin

if IdHTTPServer.Active then
    begin

    Self.Caption:=Self.Name+' Server Stopped';
    bToggleStartStopServer.Caption:='Start Server';

    idHTTPServer.Active:=false
    end else

    begin

    Self.Caption:=Self.Name+' Server Started';
    bToggleStartStopServer.Caption:='Stop Server';


    idHTTPServer.Active:=true

    end;


end;


//------------------------------------CREATE DESTROY------------

procedure TfHTTPServer.FormCreate(Sender: TObject);
begin


ReportMemoryLeaksOnShutdown:=true;

  idHTTPServer.DefaultPort := 40000;
  idHTTPServer.Active := false;

// Activating Server Here
bToggleStartStopServer.Click;

end;



procedure TfHTTPServer.IdHTTPServerCommandGet
(AContext: TIdContext; ARequestInfo: TIdHTTPRequestInfo;
  AResponseInfo: TIdHTTPResponseInfo);


var DecodePostRequest:TDecodePostRequest;
    PostParams:TStringList;


begin

  PostParams:=TStringList.Create;


  if ARequestInfo.URI=('/sendfile') then

   begin
   PostParams.Clear;

   DecodePostRequest:=TDecodePostRequest.Create(Self);
   DecodePostRequest.Decode(AContext,ARequestInfo,AResponseInfo,PostParams);
   FreeAndNil(DecodePostRequest);
   end;



if ARequestInfo.URI=('/CreateDirOnServer') then

   begin
   PostParams.Clear;
   DecodePostRequest:=TDecodePostRequest.Create(Self);
   DecodePostRequest.Decode(AContext,ARequestInfo,AResponseInfo,PostParams);
   FreeAndNil(DecodePostRequest);


   ShowMessage(

   PostParams.Values['DirectoryToCreate']

   );


   end;



if ARequestInfo.URI=('/SomeURICommand') then

   begin
   PostParams.Clear;
   DecodePostRequest:=TDecodePostRequest.Create(Self);
   DecodePostRequest.Decode(AContext,ARequestInfo,AResponseInfo,PostParams);
   FreeAndNil(DecodePostRequest);


   ShowMessage(

   'SomePOSTParam1='+

   PostParams.Values['SomePOSTParam1']

   );


   end;




  FreeAndNil(PostParams);

end;

procedure TfHTTPServer.mmo2Change(Sender: TObject);
begin

end;

//-----------------------------------------------------------






end.
